/*
 * console.h
 *
 *
 */

#ifndef CONSOLE_H_
#define CONSOLE_H_

#include <stdint.h>
#include <cocoos.h>
#include <inc/usart.h>
#include <inc/utilstypes.h>
#include <inc/queue.h>
#include <systemTime.h>


typedef utils::Queue<utils::string> StrQueue;


class Console {

public:
    Console(uint8_t prio, TimeProvider& tmPrvdr);
    ~Console();

    void create();
    void printTimestampedString(const char *str);

private:
    static void task();
    uint8_t _prio;
    static StrQueue output;
    TimeProvider& timeProvider;

};


#endif /* CONSOLE_H_ */
