/*
 * lwipif.cpp
 *
 *
 */



#include <lwipif.h>
#include <netconf.h>
#include <cocoos.h>
#include <inc/ethernet.h>
#include <lwip/tcp.h>
#include <tcpif.h>
#include <inc/pin.h>
#include <debug.h>

static Lwipif *inst;


Lwipif::Lwipif() {
    inst = this;
}

Lwipif::~Lwipif() {}

void Lwipif::create(uint8_t prio) {
    task_create( task, prio, 0, 0, 0 );
}

void Lwipif::task() {

    task_open();

    for (;;) {
        task_wait(1);

        if (inst->checkFrame()) {
            /* process received ethernet packet */
            debug_print("|<--lwipif: handle packet---\n");
            inst->handlePacket();
            debug_print("---lwipif: handle packet-->|\n");
        }

        inst->handlePeriodic();
    }

    task_close();
}

void Lwipif::init() {
    ifc.init();
    LwIP_Init();
}

void Lwipif::handlePacket() {
    LwIP_Pkt_Handle();
}

void Lwipif::handlePeriodic() {
    static uint32_t time = 0;
    static uint32_t LocalTime = 0;

    if (++time == 10) {
        LocalTime += time;
        LwIP_Periodic_Handle(LocalTime);
        time = 0;
    }
}

bool Lwipif::checkFrame() {
    return ifc.checkFrame();
}

