

#include "stm32f4x7_eth.h"
#include "netconf.h"
#include "main.h"

#include <stdio.h>
#include <inc/init.h>
#include <inc/mcu.h>
#include <inc/usart.h>
#include <inc/ethernet.h>
#include <lwipif.h>
#include <cocoos.h>
#include <inc/pin.h>
#include <console.h>
#include <tcpif.h>
#include <systemtime.h>



Evt_t tcpEvent;

int main(void)
{
    mcal::init();
    mcal::mcu::registerUserTick( 1, os_tick );

    os_disable_interrupts();
    os_init();

    tcpEvent = event_create();
    Lwipif lwip;
    lwip.create(50);
    lwip.init();

    tcpif tcp;
    tcp.create(40);
    tcp.init();

    SystemTime systemTime;
    systemTime.create(60);

    Console console(80, systemTime);
    console.create();

    /* tcp echo server Init */
    os_start();

}

